#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <vector>
#include <map>

using namespace std;

#define NMAX 2010
#define MMAX 100000
#define VMAX 13
#define INF 666666666

struct bictree_node
{
	map<int, char> *m;
	vector<int> *v;
	vector<struct bictree_node*> *fiu;
	int *wmin;
};

char A[NMAX][NMAX];
int w[NMAX], vizitat[NMAX], level[NMAX], minlevel[NMAX], stk[NMAX*NMAX/2][2];
map<int, char> mm[2 * NMAX];
vector<int> vv[2 * NMAX];
struct bictree_node *tree[NMAX];
vector<struct bictree_node*> ff[2 * NMAX];
int M, N, niv, next, inset, num, value, xa, xb, vset[NMAX], sel_stupid[NMAX];

void df_graph(int n, int tata)
{
	int i, j, x;
	struct bictree_node *t;

	//fprintf(stderr, "%d\n", n);

	vizitat[n] = 1;
	level[n] = minlevel[n] = level[tata] + 1;

	for (x = 1; x <= N; x++)
		if (A[n][x] && x != tata)
		{
			if (vizitat[x] && level[x] < level[n])
			{
				niv++;
				stk[niv][0] = n;
				stk[niv][1] = x;

				if (level[x] < minlevel[n])
					minlevel[n] = level[x];
			}
			else
			if (!vizitat[x])
			{
				niv++;
				stk[niv][0] = n;
				stk[niv][1] = x;

				df_graph(x, n);

				if (minlevel[x] >= level[n])
				{
					// n este punct critic

					if (tree[n] == NULL)
					{
						tree[n] = (struct bictree_node *) malloc(sizeof(struct bictree_node));
						
						tree[n]->m = &(mm[next]);
						tree[n]->m->clear();
						tree[n]->v = &(vv[next]);
						tree[n]->v->clear();
						tree[n]->fiu = &(ff[next]);
						tree[n]->fiu->clear();
						tree[n]->v->push_back(n);
						(*(tree[n]->m))[n] = 1;
						next++;
					}

					// o noua componenta biconexa

					t = (struct bictree_node *) malloc(sizeof(struct bictree_node));
					t->m = &(mm[next]);
					t->m->clear();
					t->v = &(vv[next]);
					t->v->clear();
					t->fiu = &(ff[next]);
					t->fiu->clear();
					t->v->push_back(n);
					(*(t->m))[n] = 1;
					t->v->push_back(x);
					(*(t->m))[x] = 2;
					next++;

					if (tree[x] != NULL)
						t->fiu->push_back(tree[x]);

					tree[n]->fiu->push_back(t);

					while (stk[niv][0] != n || stk[niv][1] != x)
					{
						i = stk[niv][0];
						j = stk[niv][1];
						niv--;

						if (!((*(t->m))[i]))
						{
							t->v->push_back(i);
							(*(t->m))[i] = t->v->size();

							if (tree[i] != NULL)
								t->fiu->push_back(tree[i]);
						}

						if (!((*(t->m))[j]))
						{
							t->v->push_back(j);
							(*(t->m))[j] = t->v->size();

							if (tree[j] != NULL)
								t->fiu->push_back(tree[j]);
						}
					}

					niv--;
				}
				else
				if (minlevel[x] < minlevel[n])
					minlevel[n] = minlevel[x];
			}
		}
}

void bkt(int idx, int cnt, vector<int> *v, int *wmin)
{
	int x, ok;

	if (idx == cnt)
	{
		wmin[num] = value;
	}
	else
	{
		inset++;
		vset[(*v)[idx]] = 1;
		num += (1 << idx);
		value += w[(*v)[idx]];

		bkt(idx + 1, cnt, v, wmin);

		num -= (1 << idx);
		value -= w[(*v)[idx]];
		vset[(*v)[idx]] = 0;
		inset--;

		ok = 1;
		for (x = 0; ok && x < idx; x++)
			if (A[(*v)[x]][(*v)[idx]] && !vset[(*v)[x]])
				ok = 0;

		if (ok)
			bkt(idx + 1, cnt, v, wmin);
	}
}

void df_bictree(struct bictree_node *n)
{
	int x, cnt, nset, y, fset, cntf, ok, z, extra;
	struct bictree_node *f;

	if (n == NULL)
		return;

	for (x = 0; x < n->fiu->size(); x++)
		df_bictree((*(n->fiu))[x]);

	cnt = n->v->size();

	if (cnt > VMAX)
	{
		fprintf(stderr, "i give up : %d\n", cnt);
		exit(0);
	}

	// bkt :)

	n->wmin = (int *) malloc((1 << cnt) * sizeof(int));

	for (x = 0; x < (1 << cnt); x++)
		n->wmin[x] = INF;

	num = value = inset = 0;
	memset(vset, 0, sizeof(vset));

	bkt(0, cnt, n->v, n->wmin);

	// values computed with bkt

	/*
	fprintf(stderr, "*****\n");
	fprintf(stderr, "%d: ", cnt);

	if (cnt > VMAX)
		fprintf(stderr, "? ");

	for (x = 0; x < cnt; x++)
		fprintf(stderr, " %d", (*(n->v))[x]);
	fprintf(stderr, "\n");

	fprintf(stderr, "nfii = %d\n", n->fiu->size());

	fprintf(stderr, "values after BKT\n");
	for (nset = 0; nset < (1 << cnt); nset++)
		fprintf(stderr, "%d: %d\n", nset, n->wmin[nset]);
	*/

	// compute best_stupid

	z = 0;
	value = INF;

	for (nset = 0; nset < (1 << cnt); nset++)
		if (n->wmin[nset] < value)
			value = n->wmin[nset], 
			z = nset;

	for (x = 0; x < n->v->size(); x++)
	{
		y = (*(n->m))[(*(n->v))[x]] - 1;

		if (z & (1 << y))
			sel_stupid[(*(n->v))[x]] = 1;
	}

	// DP
	for (nset = 0; nset < (1 << cnt); nset++)
		if (n->wmin[nset] < INF)
			for (x = 0; x < n->fiu->size(); x++)
			{
				f = (*(n->fiu))[x];
				cntf = f->v->size();
				value = INF;

				for (fset = 0; fset < (1 << cntf); fset++)
				{
					extra = f->wmin[fset];
					ok = 1;

					for (y = 0; ok && y < cntf; y++)
					{
						num = (*(f->v))[y];
						z = (*(n->m))[num] - 1;

						if (z >= 0)
						{
							if (nset & (1 << z))
								xa = 1;
							else
								xa = 0;

							if (fset & (1 << y))
								xb = 1;
							else
								xb = 0;

							if (xa != xb)
								ok = 0;

							if (xa == 1)
								extra -= w[num];
						}
					}

					if (ok && extra < value)
						value = extra;
				}
			
				n->wmin[nset] += value;
			}

	/*
	fprintf(stderr, "values after DP\n");
	for (nset = 0; nset < (1 << cnt); nset++)
		fprintf(stderr, "%d: %d\n", nset, n->wmin[nset]);
	*/
}

int find_min_value(struct bictree_node *n, int *tset, int lev)
{
	int x, y, nset, cnt, okset, value, ok;

	cnt = n->v->size();

	/*
	fprintf(stderr, "*****\n");
	fprintf(stderr, "(lev=%d) %d: ", lev, cnt);

	if (cnt > VMAX)
		fprintf(stderr, "? ");

	for (x = 0; x < cnt; x++)
		fprintf(stderr, " %d", (*(n->v))[x]);
	fprintf(stderr, "\n");

	fprintf(stderr, "nfii = %d\n", n->fiu->size());

	for (x = 1; x <= N; x++)
		fprintf(stderr, "%d ", tset[x]);
	fprintf(stderr, "\n");
	*/

	okset = 0;
	value = INF;

	for (nset = 0; nset < (1 << cnt); nset++)
		if (n->wmin[nset] < value)
		{
			//fprintf(stderr, "%d : %d\n", nset, n->wmax[nset]);

			ok = 1;
			for (x = 0; x < cnt; x++)
			{
				y = (*(n->v))[x];

				if (nset & (1 << x))
					xa = 1;
				else
					xa = 0;

				if (tset[y] != xa && tset[y] != 2)
					ok = 0;
			}

			if (ok)
			{
				value = n->wmin[nset];
				okset = nset;
			}
		}

	//fprintf(stderr, "result: okset = %d ; value = %d\n", okset, value);

	for (x = 0; x < cnt; x++)
	{
		y = (*(n->v))[x];

		if (okset & (1 << x))
			tset[y] = 1;
		else
			tset[y] = 0;
	}

	for (x = 0; x < n->fiu->size(); x++)
		find_min_value((*(n->fiu))[x], tset, lev + 1);

	return value;
}

void read_data(void)
{
	int i, j;

	freopen("ro.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++)
		scanf("%d", &w[i]);

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			A[i][j] = 0;

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}
}

void write_data(int best, int *marcat)
{
	int i, count, best_stupid;

	freopen("ro.out", "w", stdout);

	printf("%d\n", best);

	count = 0;
	for (i = 1; i <= N; i++)
		if (marcat[i] == 1)
			count++;

	printf("%d\n", count);

	for (i = 1; i <= N; i++)
		if (marcat[i] == 1)
			printf("%d ", i);

	printf("\n");

	best_stupid = 0;

	for (i = 1; i <= N; i++)
		if (sel_stupid[i])
			best_stupid += w[i];

	printf("best_stupid = %d\n", best_stupid);
}

int main()
{
	int i, best;

	read_data();

	level[0] = niv = next = 0;

	for (i = 1; i <= N; i++)
		vizitat[i] = 0,
		tree[i] = NULL;

	df_graph(1, 0);

	memset(sel_stupid, 0, sizeof(sel_stupid));

	df_bictree(tree[1]);

	for (i = 0; i <= N; i++)
		vizitat[i] = 2;

	best = find_min_value(tree[1], vizitat, 1);

	/*
	for (i = 1; i <= N; i++)
		fprintf(stderr, "%d ", vizitat[i]);

	fprintf(stderr, "\n");
	*/

	write_data(best, vizitat);

	return 0;
}
