#include <stdio.h>
#include <string.h>
#include <math.h>

#define NMAX 2010
#define INF 1e6
#define eps 1e-6
#define SINF 666666666
#define STEP 0.05

char A[NMAX][NMAX], B[NMAX][NMAX];
int sel[NMAX], w[NMAX], deg[NMAX], degB[NMAX], selok[NMAX];
double wp[NMAX], wmax, dmax, x;
int i, j, k, p, q, N, M, sum, cnt, sumok;
double t;

int main()
{
	freopen("ro.in", "r", stdin);

	scanf("%d %d", &N, &M);

	wmax = 0;

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &w[i]);

		if (w[i] > wmax)
			wmax = w[i];
	}

	memset(A, 0, sizeof(A));
	memset(deg, 0, sizeof(deg));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;

		deg[i]++;
		deg[j]++;
	}

	// greedy

	sumok = SINF;

	for (t = 0.0; t < 1.0 || fabs(t - 1.0) < eps; t += STEP)
	{
		memmove(B, A, sizeof(A));
		memmove(degB, deg, sizeof(deg));
		memset(sel, 0, sizeof(sel));

		while (1)
		{
			p = 0;

			dmax = 0;

			for (i = 1; i <= N; i++)
				if (!sel[i] && degB[i] > dmax)
					dmax = degB[i];

			x = INF;

			for (i = 1; i <= N; i++)
				if (!sel[i] && degB[i] > 0)
				{
					wp[i] = t * dmax / degB[i] + (1 - t) * (w[i] / wmax);
				
					if (wp[i] < x)
					{
						x = wp[i];
						p = i;
					}
				}

			if (p > 0)
			{
				// l-am selectat pe p

				//fprintf(stderr, "Selecting %d: deg=%d, w=%d, wp=%.3lf\n", p, degB[p], w[p], wp[p]);

				sel[p] = 1;

				for (i = 1; i <= N; i++)
					if (B[p][i])
					{
						degB[p]--;
						degB[i]--;

						B[p][i] = B[i][p] = 0;
					}
			}
			else
				break;
		}
	
		for (sum = cnt = 0, i = 1; i <= N; i++)
			if (sel[i])
			{
				sum += w[i];
				cnt++;	
			}

		fprintf(stderr, "t=%.3lf sum=%d cnt=%d\n", t, sum, cnt);

		if (sum < sumok)
		{
			sumok = sum;
			memmove(selok, sel, sizeof(sel));
		}
	}

	freopen("ro.out", "w", stdout);

	cnt = 0;

	for (i = 1; i <= N; i++)
		if (selok[i])
			cnt++;

	printf("%d\n%d\n", sumok, cnt);

	for (i = 1; i <= N; i++)
		if (selok[i])
			printf("%d ", i);

	printf("\n");

	return 0;
}
