#include <stdio.h>
#include <string.h>
#include <math.h>

#define NMAX 2010
#define INF 1e6
#define eps 1e-6
#define SINF 666666666
#define STEP 0.2

char A[NMAX][NMAX], B[NMAX][NMAX];
int sel[NMAX], w[NMAX], deg[NMAX], degB[NMAX], selok[NMAX], crit[NMAX], level[NMAX], minlevel[NMAX], vizitat[NMAX];
double wp[NMAX], wmax, dmax, x;
int i, j, k, p, q, N, M, sum, cnt, sumok, sel1;
double t1, t2, t3;

void df_graph(int n, int tata)
{
	int i, j, x, nsons = 0;

	//fprintf(stderr, "%d\n", n);

	vizitat[n] = 1;
	level[n] = minlevel[n] = level[tata] + 1;

	for (x = 1; x <= N; x++)
		if (A[n][x] && x != tata)
		{
			if (vizitat[x] && level[x] < level[n])
			{
				if (level[x] < minlevel[n])
					minlevel[n] = level[x];
			}
			else
			if (!vizitat[x])
			{
				nsons++;

				df_graph(x, n);

				if (minlevel[x] >= level[n] && n > 1)
				{
					// n este punct critic
					crit[n] = 1;
				}
				else
				if (minlevel[x] < minlevel[n])
					minlevel[n] = minlevel[x];
			}
		}

		if (n == 1 && nsons > 1)
			crit[n] = 1;
}

int main()
{
	freopen("teste\\9-ro.in", "r", stdin);
	freopen("glog.txt", "w", stderr);

	scanf("%d %d", &N, &M);

	wmax = 0;

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &w[i]);

		if (w[i] > wmax)
			wmax = w[i];
	}

	memset(A, 0, sizeof(A));
	memset(deg, 0, sizeof(deg));

	while (M--)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;

		deg[i]++;
		deg[j]++;
	}

	// find the critical points

	memset(crit, 0, sizeof(crit));
	memset(level, 0, sizeof(level));
	memset(minlevel, 0, sizeof(minlevel));
	memset(vizitat, 0, sizeof(vizitat));

	df_graph(1, 0);

	fprintf(stderr, "Noduri critice:");

	for (i = 1; i <= N; i++)
		if (crit[i])
			fprintf(stderr, " %d (%d),", i, w[i]);

	fprintf(stderr, "\n");

	// greedy

	sumok = SINF;

	for (t1 = 0.0; t1 < 1.0 || fabs(t1 - 1.0) < eps; t1 += STEP)
	for (t2 = 0.0; t2 < 1.0 || fabs(t2 - 1.0) < eps; t2 += STEP)
	for (t3 = 0.0; t3 < 1.0 || fabs(t3 - 1.0) < eps; t3 += STEP)
	for (sel1 = 0; sel1 < 2; sel1++) 
	{
		memmove(B, A, sizeof(A));
		memmove(degB, deg, sizeof(deg));
		memset(sel, 0, sizeof(sel));

		while (1)
		{
			p = 0;

			if (sel1)
			{
				// cauta noduri care au gradul 1

				for (i = 1; i <= N; i++)
					if (!sel[i] && degB[i] == 1)
					{
						p = i;
						break;
					}

				if (p > 0)
				{
					q = 0;

					for (i = 1; i <= N; i++)
						if (!sel[i] && B[p][i])
						{
							degB[p]--;
							degB[i]--;

							B[p][i] = B[i][p] = 0;

							q = i;
							break;
						}

					sel[q] = 1;

					for (i = 1; i <= N; i++)
						if (B[q][i])
						{
							degB[q]--;
							degB[i]--;

							B[q][i] = B[i][q] = 0;
						}

					continue;
				}
			}

			dmax = 0;
			for (i = 1; i <= N; i++)
				if (!sel[i] && degB[i] > dmax)
					dmax = degB[i];

			wmax = 0;

			for (i = 1; i <= N; i++)
				if (!sel[i] && degB[i] > 0 && w[i] > wmax)
					wmax = w[i];

			x = INF;

			for (i = 1; i <= N; i++)
				if (!sel[i] && degB[i] > 0)
				{
					wp[i] = t1 * (1 - crit[i]) + (t2 * dmax) / degB[i] + t3 * (w[i] / wmax);
				
					if (wp[i] < x)
					{
						x = wp[i];
						p = i;
					}
				}

			if (p > 0)
			{
				// l-am selectat pe p

				//fprintf(stderr, "Selecting %d: deg=%d, w=%d, wp=%.3lf\n", p, degB[p], w[p], wp[p]);

				sel[p] = 1;

				for (i = 1; i <= N; i++)
					if (B[p][i])
					{
						degB[p]--;
						degB[i]--;

						B[p][i] = B[i][p] = 0;
					}
			}
			else
				break;
		}
	
		for (sum = cnt = 0, i = 1; i <= N; i++)
			if (sel[i])
			{
				sum += w[i];
				cnt++;	
			}

		fprintf(stderr, "[tcrit=%.3lf tdeg=%.3lf tw=%.3lf sel1=%d] sum=%d cnt=%d\n", t1, t2, t3, sel1, sum, cnt);

		if (sum < sumok)
		{
			sumok = sum;
			memmove(selok, sel, sizeof(sel));
		}
	}

	freopen("ro.out", "w", stdout);

	cnt = 0;

	for (i = 1; i <= N; i++)
		if (selok[i])
			cnt++;

	printf("%d\n%d\n", sumok, cnt);

	for (i = 1; i <= N; i++)
		if (selok[i])
			printf("%d ", i);

	printf("\n");

	return 0;
}
