#include <stdio.h>
#include <string.h>

int N, M, K;
int G[256][256], H[256][256];
int P[256], V[256], F[256];
int B[256], D[256];
int Timer = 0;

void input(FILE *f)
{
	int i, a, b, t;

	memset(G, 0, sizeof(G));
	fscanf(f, "%d%d%d", &N, &M, &K);
	for (i = 0; i < M; i++)
		fscanf(f, "%d%d", &a, &b), G[a][b] = G[b][a] = 1;
	for (i = 0; i < N; i++)
		t = G[0][i], G[0][i] = G[K][i], G[K][i] = t,
		t = G[i][0], G[i][0] = G[i][K], G[i][K] = t;
}

#define min(u,v) ((u) < (v) ? (u) : (v))

void df_bridges(int n)
{
	int i;
	
	for (V[n] = 1, B[n] = D[n] = Timer++, i = 0; i < N; i++)
		if (G[n][i] && i != n)
		{
			if (!V[i])
			{
				P[i] = n, df_bridges(i), B[n] = min(B[n], B[i]);
				F[i] = D[n] < B[i];
			}
			else if (P[n] != i)
				B[n] = min(B[n], D[i]);
		}
}

#define check(u,v) (P[u] == (v) && F[u])
#define bridge(u,v) (check(u,v) || check(v,u))

void simplify(void)
{
	int q[256], u, v, n, i, j, c, t;
	
	for (V[q[u = v = 0] = 0] = c = 1; u <= v; )
		for (n = q[u++], i = 0; i < N; i++)
			if (!V[i] && G[n][i])
				V[q[++v] = i] = (bridge(i, n) ? ++c : V[n]);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			H[V[i] - 1][V[j] - 1] += G[i][j] * (1 + (i == j));

	K = V[0] - 1;
	N = c;
	for (i = 0; i < N; i++)
		t = G[0][i], G[0][i] = G[K][i], G[K][i] = t,
		t = G[i][0], G[i][0] = G[i][K], G[i][K] = t;
}

int df_grundy(int n)
{
	int i, s;

	for (V[n] = 1, i = s = 0; i < N; i++)
		if (!V[i] && H[n][i]) s ^= df_grundy(i) + 1;
	return s ^ ((H[n][n] >> 1) & 1);
}

void solve(FILE *f)
{
	memset(V, 0, sizeof(V));
	memset(P, 0xFFFF, sizeof(P));
	memset(F, 0, sizeof(F));
	df_bridges(0);

	memset(V, 0, sizeof(V));
	memset(H, 0, sizeof(H));
	simplify();

	memset(V, 0, sizeof(V));
	fprintf(f, "%d\n", df_grundy(0) != 0);
}

int main(void)
{
	int tmp;
	FILE *fi, *fo;

	fi = fopen("smart.in", "r");
	fo = fopen("smart.out", "w");
	for (tmp = 3; tmp; tmp--)
		input(fi), solve(fo);
	fclose(fi);
	fclose(fo);

	return 0;
}
